require "camera"
require "player"
require "physicsworld"
require "mouse"
require "keyboard"
require "worldedit"
require "AnAL"
require "utilities"

function love.load()

  setupworld()

  loadplayer()

  setupworldedit()

  mouseload()

  keyboardload()

  mapload()

  love.graphics.setBackgroundColor(200, 200, 200)

  love.graphics.setFont(15)

end

function love.update(dt)

  dt = math.min(dt, 1 / 60)  --caps fps to 60

  world:update(dt) --this puts the world into motion

  camera:move()

  worldmouseX,worldmouseY = mouseworld(love.mouse.getPosition())  --sets global variables to be used throught the program

  playeranimate()

  playerupdate(dt)

  moveplayer()

end

function love.draw()
  camera:set() --camera - - anything between the camera tags will be affected by zoom, pan, etc

  drawworld()

  drawplayer()

  camera:unset() --/camera

  love.graphics.print("Mouse: "..math.round(worldmouseX)..", "..math.round(worldmouseY), 500, 5)
  love.graphics.print("Blockmode: "..blockmode, 500, 20)

  love.graphics.print("FPS: "..love.timer.getFPS(), 300, 5) --prints fps counter
  --love.graphics.print("Lastblock: "..lastblock, 300, 20)
  love.graphics.print("Playerstate: "..playerstate, 300, 20)

  love.graphics.print("Player X: "..math.floor(playerX), 5, 20)
  love.graphics.print("Player Y: "..math.floor(playerY), 5, 35)
end