function setupworld()
	world = love.physics.newWorld( 0, 0, 1500, 1500 )
    --create a world for the bodies to exist in with width and height of 650
  world:setGravity(0, 400) --the x component and y gravity components
  world:setMeter(22) --the height of a meter in this world

  playerloaded = 0

  map = {}
  map.floor = {}
  map.body = love.physics.newBody(world, 0, 0, 0, 0)
  map.floor.shape = love.physics.newRectangleShape(map.body, 600, 300, 1190, 20, 0)
  map.floor.shape:setFriction(2)
  map.floor.shape:setData("Floor")
  map.floor.shape:setRestitution(0)

  world:setCallbacks(add, persist, remove, result)

  --world textures:
  map.img = {}
  map.img.floor1 = love.graphics.newImage("img/world/floor1.png")
  map.img.floor1:setFilter('nearest', 'nearest')
  map.img.wall1 = love.graphics.newImage("img/world/wall1.png")
  map.img.wall1:setFilter('nearest', 'nearest')
  map.img.stairs1r = love.graphics.newImage("img/world/stairs1r.png")
  map.img.stairs1r:setFilter('nearest', 'nearest')
  map.img.stairs1l = love.graphics.newImage("img/world/stairs1l.png")
  map.img.stairs1l:setFilter('nearest', 'nearest')

end

function drawworld()

  local currentblock = 1
  local x1, y1, x2, y2, x3, y3, x4, y4

  while lastblock >= currentblock do
    if block.id[currentblock] == 5 then
      x1, y1, x2, y2, x3, y3, x4, y4 = block.dat[currentblock]:getPoints()
      love.graphics.draw(map.img.floor1, x1, y1)
    elseif block.id[currentblock] == 6 then
      x1, y1, x2, y2, x3, y3, x4, y4 = block.dat[currentblock]:getPoints()
      love.graphics.draw(map.img.wall1, x1, y1)
    elseif block.id[currentblock] == 8 then
      x1, y1, x2, y2, x3, y3 = block.dat[currentblock]:getPoints()
      love.graphics.draw(map.img.stairs1l, x1, y1)
    elseif block.id[currentblock] == 9 then
      x1, y1, x2, y2, x3, y3 = block.dat[currentblock]:getPoints()
      love.graphics.draw(map.img.stairs1r, x1, y1)
    else
      love.graphics.setColor(72, 160, 14) --set line draw colour to green.
      love.graphics.polygon("line", block.dat[currentblock]:getPoints())
      love.graphics.setColor(255, 255, 255) --set the colour back to normal so we don't get a tinted player or other assets
    end
    currentblock = currentblock + 1
  end

  love.graphics.setColor(72, 160, 14)
  love.graphics.polygon("line", map.floor.shape:getPoints()) -- draw a polygon using the ground's coordinates
  love.graphics.setColor(255, 255, 255)
end

--collision callbacks
function add(a, b, col)
  local x,y
  if a == "playerfeet" or b == "playerfeet" then
    player.sensor.feet = player.sensor.feet + 1
  end
  if a == "playerright" or b == "playerright" then
    player.sensor.right = player.sensor.right + 1
    x,y = player.body:getLinearVelocity(x,y)
    player.body:setLinearVelocity(0,y)
  end
  if a == "playerleft" or b == "playerleft" then
    player.sensor.left = player.sensor.left + 1
    x,y = player.body:getLinearVelocity(x,y)
    player.body:setLinearVelocity(0,y)
  end
end
function persist(a, b, col)
  --placeholder
end
function remove(a, b, col)
  if a == "playerfeet" or b == "playerfeet" then
    player.sensor.feet = player.sensor.feet - 1
  end
  if a == "playerright" or b == "playerright" then
    player.sensor.right = player.sensor.right - 1
  end
  if a == "playerleft" or b == "playerleft" then
    player.sensor.left = player.sensor.left - 1
  end
end
function result(a, b, col)
  --placeholder
end