function setupworldedit()
  lastblock = 0

  ghostblock = nil

  map1 = nil

--keeps track of blocks in the world
  block = {}
  block.dat = {}
  block.dat[1] = nil  --holds the shape data
  block.exists = {}
  block.exists[1] = nil --boolean value for a quick looping check for collision or draw
  block.id = {}
  block.id[1] = nil --used for different block types

end

function addblocks(x,y,type)

  lastblock = lastblock + 1 --keeps track of which blocks have been placed

  block.id[lastblock] = type

--different types of block available.
  if type == 1 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 50, 50, 0)
    block.id[lastblock] = type
  elseif type == 2 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 300, 25, 0)
    block.id[lastblock] = type
  elseif type == 3 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 25, 300, 0)
    block.id[lastblock] = type
  elseif type == 4 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 100, 100, 0)
    block.id[lastblock] = type
  elseif type == 5 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 50, 10, 0)
    block.id[lastblock] = type  -- floor1
  elseif type == 6 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 12, 50, 0)
    block.id[lastblock] = type  --wall1
  elseif type == 7 then
    block.dat[lastblock] = love.physics.newRectangleShape(map.body, x, y, 100, 100, 0)
    block.id[lastblock] = type
  elseif type == 8 then
    block.dat[lastblock] = love.physics.newPolygonShape(map.body, x, y, x, y+30, x+50, y+30)
    block.id[lastblock] = type  --stairs1l
  elseif type == 9 then
    block.dat[lastblock] = love.physics.newPolygonShape(map.body, x, y, x, y+30, x-50, y+30)
    block.id[lastblock] = type  --stairs1r
  end

  block.dat[lastblock]:setRestitution(0)
  block.exists[lastblock] = 1
end

function moveblocks(x,y)  --make blocks draggable with the mouse

  local currentblock = 1

  while lastblock >= currentblock do
    if block.dat[currentblock]:testPoint(x,y) then

      block.dat[currentblock]:destroy()

      if blockmode == 1 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 50, 50, 0)
      elseif blockmode == 2 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 300, 25, 0)
      elseif blockmode == 3 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 25, 300, 0)
      elseif blockmode == 4 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 100, 100, 0)
      elseif blockmode == 5 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 50, 10, 0)
      elseif blockmode == 6 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 12, 50, 0)
      elseif blockmode == 7 then
        block.dat[currentblock] = love.physics.newRectangleShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), 100, 100, 0)
      elseif blockmode == 8 then
        block.dat[currentblock] = love.physics.newPolygonShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), x, y+30, x+50, y+30)
      elseif blockmode == 9 then
        block.dat[currentblock] = love.physics.newPolygonShape(map.body, roundfactor(worldmouseX, 4), roundfactor(worldmouseY, 4), x, y+30, x-50, y+30)
      end
    end
    currentblock = currentblock + 1
  end
end

function mapload()

  map.loadfunction = love.filesystem.load("dat/map1.platmap")

  map.loadfunction()

end

function mapsave()
  
end